// +build go1.9

// Copyright 2017 Microsoft Corporation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// This code was auto-generated by:
// github.com/Azure/azure-sdk-for-go/tools/profileBuilder
// commit ID: dab57ee609fffdc578f48519d5cdc980efd8cc00

package datafactory

import original "github.com/Azure/azure-sdk-for-go/services/datafactory/mgmt/2017-09-01-preview/datafactory"

type LinkedServicesClient = original.LinkedServicesClient
type AuthenticationType = original.AuthenticationType

const (
	AuthenticationTypeAnonymous         AuthenticationType = original.AuthenticationTypeAnonymous
	AuthenticationTypeBasic             AuthenticationType = original.AuthenticationTypeBasic
	AuthenticationTypeClientCertificate AuthenticationType = original.AuthenticationTypeClientCertificate
)

type AzureSearchIndexWriteBehaviorType = original.AzureSearchIndexWriteBehaviorType

const (
	Merge  AzureSearchIndexWriteBehaviorType = original.Merge
	Upload AzureSearchIndexWriteBehaviorType = original.Upload
)

type CassandraSourceReadConsistencyLevels = original.CassandraSourceReadConsistencyLevels

const (
	ALL         CassandraSourceReadConsistencyLevels = original.ALL
	EACHQUORUM  CassandraSourceReadConsistencyLevels = original.EACHQUORUM
	LOCALONE    CassandraSourceReadConsistencyLevels = original.LOCALONE
	LOCALQUORUM CassandraSourceReadConsistencyLevels = original.LOCALQUORUM
	LOCALSERIAL CassandraSourceReadConsistencyLevels = original.LOCALSERIAL
	ONE         CassandraSourceReadConsistencyLevels = original.ONE
	QUORUM      CassandraSourceReadConsistencyLevels = original.QUORUM
	SERIAL      CassandraSourceReadConsistencyLevels = original.SERIAL
	THREE       CassandraSourceReadConsistencyLevels = original.THREE
	TWO         CassandraSourceReadConsistencyLevels = original.TWO
)

type CopyBehaviorType = original.CopyBehaviorType

const (
	FlattenHierarchy  CopyBehaviorType = original.FlattenHierarchy
	MergeFiles        CopyBehaviorType = original.MergeFiles
	PreserveHierarchy CopyBehaviorType = original.PreserveHierarchy
)

type DatasetCompressionLevel = original.DatasetCompressionLevel

const (
	Fastest DatasetCompressionLevel = original.Fastest
	Optimal DatasetCompressionLevel = original.Optimal
)

type DayOfWeek = original.DayOfWeek

const (
	Friday    DayOfWeek = original.Friday
	Monday    DayOfWeek = original.Monday
	Saturday  DayOfWeek = original.Saturday
	Sunday    DayOfWeek = original.Sunday
	Thursday  DayOfWeek = original.Thursday
	Tuesday   DayOfWeek = original.Tuesday
	Wednesday DayOfWeek = original.Wednesday
)

type DaysOfWeek = original.DaysOfWeek

const (
	DaysOfWeekFriday    DaysOfWeek = original.DaysOfWeekFriday
	DaysOfWeekMonday    DaysOfWeek = original.DaysOfWeekMonday
	DaysOfWeekSaturday  DaysOfWeek = original.DaysOfWeekSaturday
	DaysOfWeekSunday    DaysOfWeek = original.DaysOfWeekSunday
	DaysOfWeekThursday  DaysOfWeek = original.DaysOfWeekThursday
	DaysOfWeekTuesday   DaysOfWeek = original.DaysOfWeekTuesday
	DaysOfWeekWednesday DaysOfWeek = original.DaysOfWeekWednesday
)

type Db2AuthenticationType = original.Db2AuthenticationType

const (
	Basic Db2AuthenticationType = original.Basic
)

type DependencyCondition = original.DependencyCondition

const (
	Completed DependencyCondition = original.Completed
	Failed    DependencyCondition = original.Failed
	Skipped   DependencyCondition = original.Skipped
	Succeeded DependencyCondition = original.Succeeded
)

type FtpAuthenticationType = original.FtpAuthenticationType

const (
	FtpAuthenticationTypeAnonymous FtpAuthenticationType = original.FtpAuthenticationTypeAnonymous
	FtpAuthenticationTypeBasic     FtpAuthenticationType = original.FtpAuthenticationTypeBasic
)

type HDInsightActivityDebugInfoOption = original.HDInsightActivityDebugInfoOption

const (
	Always  HDInsightActivityDebugInfoOption = original.Always
	Failure HDInsightActivityDebugInfoOption = original.Failure
	None    HDInsightActivityDebugInfoOption = original.None
)

type HTTPAuthenticationType = original.HTTPAuthenticationType

const (
	HTTPAuthenticationTypeAnonymous         HTTPAuthenticationType = original.HTTPAuthenticationTypeAnonymous
	HTTPAuthenticationTypeBasic             HTTPAuthenticationType = original.HTTPAuthenticationTypeBasic
	HTTPAuthenticationTypeClientCertificate HTTPAuthenticationType = original.HTTPAuthenticationTypeClientCertificate
	HTTPAuthenticationTypeDigest            HTTPAuthenticationType = original.HTTPAuthenticationTypeDigest
	HTTPAuthenticationTypeWindows           HTTPAuthenticationType = original.HTTPAuthenticationTypeWindows
)

type IntegrationRuntimeAuthKeyName = original.IntegrationRuntimeAuthKeyName

const (
	AuthKey1 IntegrationRuntimeAuthKeyName = original.AuthKey1
	AuthKey2 IntegrationRuntimeAuthKeyName = original.AuthKey2
)

type IntegrationRuntimeAutoUpdate = original.IntegrationRuntimeAutoUpdate

const (
	Off IntegrationRuntimeAutoUpdate = original.Off
	On  IntegrationRuntimeAutoUpdate = original.On
)

type IntegrationRuntimeInternalChannelEncryptionMode = original.IntegrationRuntimeInternalChannelEncryptionMode

const (
	NotEncrypted IntegrationRuntimeInternalChannelEncryptionMode = original.NotEncrypted
	NotSet       IntegrationRuntimeInternalChannelEncryptionMode = original.NotSet
	SslEncrypted IntegrationRuntimeInternalChannelEncryptionMode = original.SslEncrypted
)

type IntegrationRuntimeSsisCatalogPricingTier = original.IntegrationRuntimeSsisCatalogPricingTier

const (
	IntegrationRuntimeSsisCatalogPricingTierBasic     IntegrationRuntimeSsisCatalogPricingTier = original.IntegrationRuntimeSsisCatalogPricingTierBasic
	IntegrationRuntimeSsisCatalogPricingTierPremium   IntegrationRuntimeSsisCatalogPricingTier = original.IntegrationRuntimeSsisCatalogPricingTierPremium
	IntegrationRuntimeSsisCatalogPricingTierPremiumRS IntegrationRuntimeSsisCatalogPricingTier = original.IntegrationRuntimeSsisCatalogPricingTierPremiumRS
	IntegrationRuntimeSsisCatalogPricingTierStandard  IntegrationRuntimeSsisCatalogPricingTier = original.IntegrationRuntimeSsisCatalogPricingTierStandard
)

type IntegrationRuntimeState = original.IntegrationRuntimeState

const (
	Initial          IntegrationRuntimeState = original.Initial
	Limited          IntegrationRuntimeState = original.Limited
	NeedRegistration IntegrationRuntimeState = original.NeedRegistration
	Offline          IntegrationRuntimeState = original.Offline
	Online           IntegrationRuntimeState = original.Online
	Started          IntegrationRuntimeState = original.Started
	Starting         IntegrationRuntimeState = original.Starting
	Stopped          IntegrationRuntimeState = original.Stopped
	Stopping         IntegrationRuntimeState = original.Stopping
)

type IntegrationRuntimeUpdateResult = original.IntegrationRuntimeUpdateResult

const (
	Fail    IntegrationRuntimeUpdateResult = original.Fail
	Succeed IntegrationRuntimeUpdateResult = original.Succeed
)

type JSONFormatFilePattern = original.JSONFormatFilePattern

const (
	ArrayOfObjects JSONFormatFilePattern = original.ArrayOfObjects
	SetOfObjects   JSONFormatFilePattern = original.SetOfObjects
)

type ManagedIntegrationRuntimeNodeStatus = original.ManagedIntegrationRuntimeNodeStatus

const (
	ManagedIntegrationRuntimeNodeStatusAvailable   ManagedIntegrationRuntimeNodeStatus = original.ManagedIntegrationRuntimeNodeStatusAvailable
	ManagedIntegrationRuntimeNodeStatusRecycling   ManagedIntegrationRuntimeNodeStatus = original.ManagedIntegrationRuntimeNodeStatusRecycling
	ManagedIntegrationRuntimeNodeStatusStarting    ManagedIntegrationRuntimeNodeStatus = original.ManagedIntegrationRuntimeNodeStatusStarting
	ManagedIntegrationRuntimeNodeStatusUnavailable ManagedIntegrationRuntimeNodeStatus = original.ManagedIntegrationRuntimeNodeStatusUnavailable
)

type MongoDbAuthenticationType = original.MongoDbAuthenticationType

const (
	MongoDbAuthenticationTypeAnonymous MongoDbAuthenticationType = original.MongoDbAuthenticationTypeAnonymous
	MongoDbAuthenticationTypeBasic     MongoDbAuthenticationType = original.MongoDbAuthenticationTypeBasic
)

type ODataAuthenticationType = original.ODataAuthenticationType

const (
	ODataAuthenticationTypeAnonymous ODataAuthenticationType = original.ODataAuthenticationTypeAnonymous
	ODataAuthenticationTypeBasic     ODataAuthenticationType = original.ODataAuthenticationTypeBasic
)

type ParameterType = original.ParameterType

const (
	Array  ParameterType = original.Array
	Bool   ParameterType = original.Bool
	Float  ParameterType = original.Float
	Int    ParameterType = original.Int
	Object ParameterType = original.Object
	String ParameterType = original.String
)

type PipelineRunQueryFilterOperand = original.PipelineRunQueryFilterOperand

const (
	PipelineName PipelineRunQueryFilterOperand = original.PipelineName
	RunEnd       PipelineRunQueryFilterOperand = original.RunEnd
	RunStart     PipelineRunQueryFilterOperand = original.RunStart
	Status       PipelineRunQueryFilterOperand = original.Status
)

type PipelineRunQueryFilterOperator = original.PipelineRunQueryFilterOperator

const (
	Equals    PipelineRunQueryFilterOperator = original.Equals
	In        PipelineRunQueryFilterOperator = original.In
	NotEquals PipelineRunQueryFilterOperator = original.NotEquals
	NotIn     PipelineRunQueryFilterOperator = original.NotIn
)

type PipelineRunQueryOrder = original.PipelineRunQueryOrder

const (
	ASC  PipelineRunQueryOrder = original.ASC
	DESC PipelineRunQueryOrder = original.DESC
)

type PipelineRunQueryOrderByField = original.PipelineRunQueryOrderByField

const (
	PipelineRunQueryOrderByFieldRunEnd   PipelineRunQueryOrderByField = original.PipelineRunQueryOrderByFieldRunEnd
	PipelineRunQueryOrderByFieldRunStart PipelineRunQueryOrderByField = original.PipelineRunQueryOrderByFieldRunStart
)

type PolybaseSettingsRejectType = original.PolybaseSettingsRejectType

const (
	Percentage PolybaseSettingsRejectType = original.Percentage
	Value      PolybaseSettingsRejectType = original.Value
)

type RecurrenceFrequency = original.RecurrenceFrequency

const (
	Day          RecurrenceFrequency = original.Day
	Hour         RecurrenceFrequency = original.Hour
	Minute       RecurrenceFrequency = original.Minute
	Month        RecurrenceFrequency = original.Month
	NotSpecified RecurrenceFrequency = original.NotSpecified
	Week         RecurrenceFrequency = original.Week
	Year         RecurrenceFrequency = original.Year
)

type SalesforceSinkWriteBehavior = original.SalesforceSinkWriteBehavior

const (
	Insert SalesforceSinkWriteBehavior = original.Insert
	Upsert SalesforceSinkWriteBehavior = original.Upsert
)

type SapHanaAuthenticationType = original.SapHanaAuthenticationType

const (
	SapHanaAuthenticationTypeBasic   SapHanaAuthenticationType = original.SapHanaAuthenticationTypeBasic
	SapHanaAuthenticationTypeWindows SapHanaAuthenticationType = original.SapHanaAuthenticationTypeWindows
)

type SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatus

const (
	SelfHostedIntegrationRuntimeNodeStatusInitializeFailed SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatusInitializeFailed
	SelfHostedIntegrationRuntimeNodeStatusInitializing     SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatusInitializing
	SelfHostedIntegrationRuntimeNodeStatusLimited          SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatusLimited
	SelfHostedIntegrationRuntimeNodeStatusNeedRegistration SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatusNeedRegistration
	SelfHostedIntegrationRuntimeNodeStatusOffline          SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatusOffline
	SelfHostedIntegrationRuntimeNodeStatusOnline           SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatusOnline
	SelfHostedIntegrationRuntimeNodeStatusUpgrading        SelfHostedIntegrationRuntimeNodeStatus = original.SelfHostedIntegrationRuntimeNodeStatusUpgrading
)

type SftpAuthenticationType = original.SftpAuthenticationType

const (
	SftpAuthenticationTypeBasic        SftpAuthenticationType = original.SftpAuthenticationTypeBasic
	SftpAuthenticationTypeSSHPublicKey SftpAuthenticationType = original.SftpAuthenticationTypeSSHPublicKey
)

type StoredProcedureParameterType = original.StoredProcedureParameterType

const (
	StoredProcedureParameterTypeBoolean StoredProcedureParameterType = original.StoredProcedureParameterTypeBoolean
	StoredProcedureParameterTypeDate    StoredProcedureParameterType = original.StoredProcedureParameterTypeDate
	StoredProcedureParameterTypeDecimal StoredProcedureParameterType = original.StoredProcedureParameterTypeDecimal
	StoredProcedureParameterTypeGUID    StoredProcedureParameterType = original.StoredProcedureParameterTypeGUID
	StoredProcedureParameterTypeInt     StoredProcedureParameterType = original.StoredProcedureParameterTypeInt
	StoredProcedureParameterTypeString  StoredProcedureParameterType = original.StoredProcedureParameterTypeString
)

type SybaseAuthenticationType = original.SybaseAuthenticationType

const (
	SybaseAuthenticationTypeBasic   SybaseAuthenticationType = original.SybaseAuthenticationTypeBasic
	SybaseAuthenticationTypeWindows SybaseAuthenticationType = original.SybaseAuthenticationTypeWindows
)

type TeradataAuthenticationType = original.TeradataAuthenticationType

const (
	TeradataAuthenticationTypeBasic   TeradataAuthenticationType = original.TeradataAuthenticationTypeBasic
	TeradataAuthenticationTypeWindows TeradataAuthenticationType = original.TeradataAuthenticationTypeWindows
)

type TriggerRunStatus = original.TriggerRunStatus

const (
	TriggerRunStatusFailed     TriggerRunStatus = original.TriggerRunStatusFailed
	TriggerRunStatusInprogress TriggerRunStatus = original.TriggerRunStatusInprogress
	TriggerRunStatusSucceeded  TriggerRunStatus = original.TriggerRunStatusSucceeded
)

type TriggerRuntimeState = original.TriggerRuntimeState

const (
	TriggerRuntimeStateDisabled TriggerRuntimeState = original.TriggerRuntimeStateDisabled
	TriggerRuntimeStateStarted  TriggerRuntimeState = original.TriggerRuntimeStateStarted
	TriggerRuntimeStateStopped  TriggerRuntimeState = original.TriggerRuntimeStateStopped
)

type Type = original.Type

const (
	TypeAzureKeyVaultSecret Type = original.TypeAzureKeyVaultSecret
	TypeSecureString        Type = original.TypeSecureString
)

type TypeActivity = original.TypeActivity

const (
	TypeAzureMLBatchExecution    TypeActivity = original.TypeAzureMLBatchExecution
	TypeAzureMLUpdateResource    TypeActivity = original.TypeAzureMLUpdateResource
	TypeContainer                TypeActivity = original.TypeContainer
	TypeCopy                     TypeActivity = original.TypeCopy
	TypeCustom                   TypeActivity = original.TypeCustom
	TypeDataLakeAnalyticsUSQL    TypeActivity = original.TypeDataLakeAnalyticsUSQL
	TypeExecutePipeline          TypeActivity = original.TypeExecutePipeline
	TypeExecution                TypeActivity = original.TypeExecution
	TypeForEach                  TypeActivity = original.TypeForEach
	TypeGetMetadata              TypeActivity = original.TypeGetMetadata
	TypeHDInsightHive            TypeActivity = original.TypeHDInsightHive
	TypeHDInsightMapReduce       TypeActivity = original.TypeHDInsightMapReduce
	TypeHDInsightPig             TypeActivity = original.TypeHDInsightPig
	TypeHDInsightSpark           TypeActivity = original.TypeHDInsightSpark
	TypeHDInsightStreaming       TypeActivity = original.TypeHDInsightStreaming
	TypeIfCondition              TypeActivity = original.TypeIfCondition
	TypeLookup                   TypeActivity = original.TypeLookup
	TypeSQLServerStoredProcedure TypeActivity = original.TypeSQLServerStoredProcedure
	TypeUntil                    TypeActivity = original.TypeUntil
	TypeWait                     TypeActivity = original.TypeWait
	TypeWebActivity              TypeActivity = original.TypeWebActivity
)

type TypeCopySink = original.TypeCopySink

const (
	TypeAzureDataLakeStoreSink   TypeCopySink = original.TypeAzureDataLakeStoreSink
	TypeAzureQueueSink           TypeCopySink = original.TypeAzureQueueSink
	TypeAzureSearchIndexSink     TypeCopySink = original.TypeAzureSearchIndexSink
	TypeAzureTableSink           TypeCopySink = original.TypeAzureTableSink
	TypeBlobSink                 TypeCopySink = original.TypeBlobSink
	TypeDocumentDbCollectionSink TypeCopySink = original.TypeDocumentDbCollectionSink
	TypeDynamicsSink             TypeCopySink = original.TypeDynamicsSink
	TypeFileSystemSink           TypeCopySink = original.TypeFileSystemSink
	TypeOdbcSink                 TypeCopySink = original.TypeOdbcSink
	TypeOracleSink               TypeCopySink = original.TypeOracleSink
	TypeSalesforceSink           TypeCopySink = original.TypeSalesforceSink
	TypeSQLDWSink                TypeCopySink = original.TypeSQLDWSink
	TypeSQLSink                  TypeCopySink = original.TypeSQLSink
)

type TypeCopySource = original.TypeCopySource

const (
	TypeAmazonRedshiftSource       TypeCopySource = original.TypeAmazonRedshiftSource
	TypeAzureDataLakeStoreSource   TypeCopySource = original.TypeAzureDataLakeStoreSource
	TypeAzureMySQLSource           TypeCopySource = original.TypeAzureMySQLSource
	TypeAzureTableSource           TypeCopySource = original.TypeAzureTableSource
	TypeBlobSource                 TypeCopySource = original.TypeBlobSource
	TypeCassandraSource            TypeCopySource = original.TypeCassandraSource
	TypeDocumentDbCollectionSource TypeCopySource = original.TypeDocumentDbCollectionSource
	TypeDynamicsSource             TypeCopySource = original.TypeDynamicsSource
	TypeFileSystemSource           TypeCopySource = original.TypeFileSystemSource
	TypeHdfsSource                 TypeCopySource = original.TypeHdfsSource
	TypeHTTPSource                 TypeCopySource = original.TypeHTTPSource
	TypeMongoDbSource              TypeCopySource = original.TypeMongoDbSource
	TypeOracleSource               TypeCopySource = original.TypeOracleSource
	TypeRelationalSource           TypeCopySource = original.TypeRelationalSource
	TypeSalesforceSource           TypeCopySource = original.TypeSalesforceSource
	TypeSapCloudForCustomerSource  TypeCopySource = original.TypeSapCloudForCustomerSource
	TypeSQLDWSource                TypeCopySource = original.TypeSQLDWSource
	TypeSQLSource                  TypeCopySource = original.TypeSQLSource
	TypeWebSource                  TypeCopySource = original.TypeWebSource
)

type TypeCopyTranslator = original.TypeCopyTranslator

const (
	TypeTabularTranslator TypeCopyTranslator = original.TypeTabularTranslator
)

type TypeDataset = original.TypeDataset

const (
	TypeAmazonS3Object              TypeDataset = original.TypeAmazonS3Object
	TypeAzureBlob                   TypeDataset = original.TypeAzureBlob
	TypeAzureDataLakeStoreFile      TypeDataset = original.TypeAzureDataLakeStoreFile
	TypeAzureMySQLTable             TypeDataset = original.TypeAzureMySQLTable
	TypeAzureSearchIndex            TypeDataset = original.TypeAzureSearchIndex
	TypeAzureSQLDWTable             TypeDataset = original.TypeAzureSQLDWTable
	TypeAzureSQLTable               TypeDataset = original.TypeAzureSQLTable
	TypeAzureTable                  TypeDataset = original.TypeAzureTable
	TypeCassandraTable              TypeDataset = original.TypeCassandraTable
	TypeCustomDataset               TypeDataset = original.TypeCustomDataset
	TypeDocumentDbCollection        TypeDataset = original.TypeDocumentDbCollection
	TypeDynamicsEntity              TypeDataset = original.TypeDynamicsEntity
	TypeFileShare                   TypeDataset = original.TypeFileShare
	TypeHTTPFile                    TypeDataset = original.TypeHTTPFile
	TypeMongoDbCollection           TypeDataset = original.TypeMongoDbCollection
	TypeODataResource               TypeDataset = original.TypeODataResource
	TypeOracleTable                 TypeDataset = original.TypeOracleTable
	TypeRelationalTable             TypeDataset = original.TypeRelationalTable
	TypeSalesforceObject            TypeDataset = original.TypeSalesforceObject
	TypeSapCloudForCustomerResource TypeDataset = original.TypeSapCloudForCustomerResource
	TypeSQLServerTable              TypeDataset = original.TypeSQLServerTable
	TypeWebTable                    TypeDataset = original.TypeWebTable
)

type TypeDatasetCompression = original.TypeDatasetCompression

const (
	TypeBZip2   TypeDatasetCompression = original.TypeBZip2
	TypeDeflate TypeDatasetCompression = original.TypeDeflate
	TypeGZip    TypeDatasetCompression = original.TypeGZip
)

type TypeDatasetPartitionValue = original.TypeDatasetPartitionValue

const (
	TypeDateTime TypeDatasetPartitionValue = original.TypeDateTime
)

type TypeDatasetStorageFormat = original.TypeDatasetStorageFormat

const (
	TypeAvroFormat    TypeDatasetStorageFormat = original.TypeAvroFormat
	TypeJSONFormat    TypeDatasetStorageFormat = original.TypeJSONFormat
	TypeOrcFormat     TypeDatasetStorageFormat = original.TypeOrcFormat
	TypeParquetFormat TypeDatasetStorageFormat = original.TypeParquetFormat
	TypeTextFormat    TypeDatasetStorageFormat = original.TypeTextFormat
)

type TypeIntegrationRuntime = original.TypeIntegrationRuntime

const (
	TypeManaged    TypeIntegrationRuntime = original.TypeManaged
	TypeSelfHosted TypeIntegrationRuntime = original.TypeSelfHosted
)

type TypeIntegrationRuntimeStatus = original.TypeIntegrationRuntimeStatus

const (
	TypeIntegrationRuntimeStatusTypeManaged    TypeIntegrationRuntimeStatus = original.TypeIntegrationRuntimeStatusTypeManaged
	TypeIntegrationRuntimeStatusTypeSelfHosted TypeIntegrationRuntimeStatus = original.TypeIntegrationRuntimeStatusTypeSelfHosted
)

type TypeLinkedService = original.TypeLinkedService

const (
	TypeAmazonRedshift         TypeLinkedService = original.TypeAmazonRedshift
	TypeAmazonS3               TypeLinkedService = original.TypeAmazonS3
	TypeAzureBatch             TypeLinkedService = original.TypeAzureBatch
	TypeAzureDataLakeAnalytics TypeLinkedService = original.TypeAzureDataLakeAnalytics
	TypeAzureDataLakeStore     TypeLinkedService = original.TypeAzureDataLakeStore
	TypeAzureKeyVault          TypeLinkedService = original.TypeAzureKeyVault
	TypeAzureML                TypeLinkedService = original.TypeAzureML
	TypeAzureMySQL             TypeLinkedService = original.TypeAzureMySQL
	TypeAzureSearch            TypeLinkedService = original.TypeAzureSearch
	TypeAzureSQLDatabase       TypeLinkedService = original.TypeAzureSQLDatabase
	TypeAzureSQLDW             TypeLinkedService = original.TypeAzureSQLDW
	TypeAzureStorage           TypeLinkedService = original.TypeAzureStorage
	TypeCassandra              TypeLinkedService = original.TypeCassandra
	TypeCosmosDb               TypeLinkedService = original.TypeCosmosDb
	TypeCustomDataSource       TypeLinkedService = original.TypeCustomDataSource
	TypeDb2                    TypeLinkedService = original.TypeDb2
	TypeDynamics               TypeLinkedService = original.TypeDynamics
	TypeFileServer             TypeLinkedService = original.TypeFileServer
	TypeFtpServer              TypeLinkedService = original.TypeFtpServer
	TypeHdfs                   TypeLinkedService = original.TypeHdfs
	TypeHDInsight              TypeLinkedService = original.TypeHDInsight
	TypeHDInsightOnDemand      TypeLinkedService = original.TypeHDInsightOnDemand
	TypeHTTPServer             TypeLinkedService = original.TypeHTTPServer
	TypeMongoDb                TypeLinkedService = original.TypeMongoDb
	TypeMySQL                  TypeLinkedService = original.TypeMySQL
	TypeOData                  TypeLinkedService = original.TypeOData
	TypeOdbc                   TypeLinkedService = original.TypeOdbc
	TypeOracle                 TypeLinkedService = original.TypeOracle
	TypePostgreSQL             TypeLinkedService = original.TypePostgreSQL
	TypeSalesforce             TypeLinkedService = original.TypeSalesforce
	TypeSapBW                  TypeLinkedService = original.TypeSapBW
	TypeSapCloudForCustomer    TypeLinkedService = original.TypeSapCloudForCustomer
	TypeSapHana                TypeLinkedService = original.TypeSapHana
	TypeSftp                   TypeLinkedService = original.TypeSftp
	TypeSQLServer              TypeLinkedService = original.TypeSQLServer
	TypeSybase                 TypeLinkedService = original.TypeSybase
	TypeTeradata               TypeLinkedService = original.TypeTeradata
	TypeWeb                    TypeLinkedService = original.TypeWeb
)

type TypeTrigger = original.TypeTrigger

const (
	TypeBlobTrigger     TypeTrigger = original.TypeBlobTrigger
	TypeScheduleTrigger TypeTrigger = original.TypeScheduleTrigger
)

type WebActivityMethod = original.WebActivityMethod

const (
	GET  WebActivityMethod = original.GET
	POST WebActivityMethod = original.POST
	PUT  WebActivityMethod = original.PUT
)

type Activity = original.Activity
type ActivityDependency = original.ActivityDependency
type ActivityPolicy = original.ActivityPolicy
type ActivityRun = original.ActivityRun
type ActivityRunsListResponse = original.ActivityRunsListResponse
type AmazonRedshiftLinkedService = original.AmazonRedshiftLinkedService
type AmazonRedshiftLinkedServiceTypeProperties = original.AmazonRedshiftLinkedServiceTypeProperties
type AmazonRedshiftSource = original.AmazonRedshiftSource
type AmazonS3Dataset = original.AmazonS3Dataset
type AmazonS3DatasetTypeProperties = original.AmazonS3DatasetTypeProperties
type AmazonS3LinkedService = original.AmazonS3LinkedService
type AmazonS3LinkedServiceTypeProperties = original.AmazonS3LinkedServiceTypeProperties
type AvroFormat = original.AvroFormat
type AzureBatchLinkedService = original.AzureBatchLinkedService
type AzureBatchLinkedServiceTypeProperties = original.AzureBatchLinkedServiceTypeProperties
type AzureBlobDataset = original.AzureBlobDataset
type AzureBlobDatasetTypeProperties = original.AzureBlobDatasetTypeProperties
type AzureDataLakeAnalyticsLinkedService = original.AzureDataLakeAnalyticsLinkedService
type AzureDataLakeAnalyticsLinkedServiceTypeProperties = original.AzureDataLakeAnalyticsLinkedServiceTypeProperties
type AzureDataLakeStoreDataset = original.AzureDataLakeStoreDataset
type AzureDataLakeStoreDatasetTypeProperties = original.AzureDataLakeStoreDatasetTypeProperties
type AzureDataLakeStoreLinkedService = original.AzureDataLakeStoreLinkedService
type AzureDataLakeStoreLinkedServiceTypeProperties = original.AzureDataLakeStoreLinkedServiceTypeProperties
type AzureDataLakeStoreSink = original.AzureDataLakeStoreSink
type AzureDataLakeStoreSource = original.AzureDataLakeStoreSource
type AzureKeyVaultLinkedService = original.AzureKeyVaultLinkedService
type AzureKeyVaultLinkedServiceTypeProperties = original.AzureKeyVaultLinkedServiceTypeProperties
type AzureKeyVaultSecretReference = original.AzureKeyVaultSecretReference
type AzureMLBatchExecutionActivity = original.AzureMLBatchExecutionActivity
type AzureMLBatchExecutionActivityTypeProperties = original.AzureMLBatchExecutionActivityTypeProperties
type AzureMLLinkedService = original.AzureMLLinkedService
type AzureMLLinkedServiceTypeProperties = original.AzureMLLinkedServiceTypeProperties
type AzureMLUpdateResourceActivity = original.AzureMLUpdateResourceActivity
type AzureMLUpdateResourceActivityTypeProperties = original.AzureMLUpdateResourceActivityTypeProperties
type AzureMLWebServiceFile = original.AzureMLWebServiceFile
type AzureMySQLLinkedService = original.AzureMySQLLinkedService
type AzureMySQLLinkedServiceTypeProperties = original.AzureMySQLLinkedServiceTypeProperties
type AzureMySQLSource = original.AzureMySQLSource
type AzureMySQLTableDataset = original.AzureMySQLTableDataset
type AzureMySQLTableDatasetTypeProperties = original.AzureMySQLTableDatasetTypeProperties
type AzureQueueSink = original.AzureQueueSink
type AzureSearchIndexDataset = original.AzureSearchIndexDataset
type AzureSearchIndexDatasetTypeProperties = original.AzureSearchIndexDatasetTypeProperties
type AzureSearchIndexSink = original.AzureSearchIndexSink
type AzureSearchLinkedService = original.AzureSearchLinkedService
type AzureSearchLinkedServiceTypeProperties = original.AzureSearchLinkedServiceTypeProperties
type AzureSQLDatabaseLinkedService = original.AzureSQLDatabaseLinkedService
type AzureSQLDatabaseLinkedServiceTypeProperties = original.AzureSQLDatabaseLinkedServiceTypeProperties
type AzureSQLDWLinkedService = original.AzureSQLDWLinkedService
type AzureSQLDWLinkedServiceTypeProperties = original.AzureSQLDWLinkedServiceTypeProperties
type AzureSQLDWTableDataset = original.AzureSQLDWTableDataset
type AzureSQLDWTableDatasetTypeProperties = original.AzureSQLDWTableDatasetTypeProperties
type AzureSQLTableDataset = original.AzureSQLTableDataset
type AzureSQLTableDatasetTypeProperties = original.AzureSQLTableDatasetTypeProperties
type AzureStorageLinkedService = original.AzureStorageLinkedService
type AzureStorageLinkedServiceTypeProperties = original.AzureStorageLinkedServiceTypeProperties
type AzureTableDataset = original.AzureTableDataset
type AzureTableDatasetTypeProperties = original.AzureTableDatasetTypeProperties
type AzureTableSink = original.AzureTableSink
type AzureTableSource = original.AzureTableSource
type BlobSink = original.BlobSink
type BlobSource = original.BlobSource
type BlobTrigger = original.BlobTrigger
type BlobTriggerTypeProperties = original.BlobTriggerTypeProperties
type CassandraLinkedService = original.CassandraLinkedService
type CassandraLinkedServiceTypeProperties = original.CassandraLinkedServiceTypeProperties
type CassandraSource = original.CassandraSource
type CassandraTableDataset = original.CassandraTableDataset
type CassandraTableDatasetTypeProperties = original.CassandraTableDatasetTypeProperties
type ControlActivity = original.ControlActivity
type CopyActivity = original.CopyActivity
type CopyActivityTypeProperties = original.CopyActivityTypeProperties
type CopySink = original.CopySink
type CopySource = original.CopySource
type CopyTranslator = original.CopyTranslator
type CosmosDbLinkedService = original.CosmosDbLinkedService
type CosmosDbLinkedServiceTypeProperties = original.CosmosDbLinkedServiceTypeProperties
type CreateRunResponse = original.CreateRunResponse
type CustomActivity = original.CustomActivity
type CustomActivityReferenceObject = original.CustomActivityReferenceObject
type CustomActivityTypeProperties = original.CustomActivityTypeProperties
type CustomDataset = original.CustomDataset
type CustomDataSourceLinkedService = original.CustomDataSourceLinkedService
type DataLakeAnalyticsUSQLActivity = original.DataLakeAnalyticsUSQLActivity
type DataLakeAnalyticsUSQLActivityTypeProperties = original.DataLakeAnalyticsUSQLActivityTypeProperties
type Dataset = original.Dataset
type DatasetBZip2Compression = original.DatasetBZip2Compression
type DatasetCompression = original.DatasetCompression
type DatasetDateTimePartitionValue = original.DatasetDateTimePartitionValue
type DatasetDeflateCompression = original.DatasetDeflateCompression
type DatasetGZipCompression = original.DatasetGZipCompression
type DatasetListResponse = original.DatasetListResponse
type DatasetPartition = original.DatasetPartition
type DatasetPartitionValue = original.DatasetPartitionValue
type DatasetReference = original.DatasetReference
type DatasetResource = original.DatasetResource
type DatasetStorageFormat = original.DatasetStorageFormat
type Db2LinkedService = original.Db2LinkedService
type Db2LinkedServiceTypeProperties = original.Db2LinkedServiceTypeProperties
type DistcpSettings = original.DistcpSettings
type DocumentDbCollectionDataset = original.DocumentDbCollectionDataset
type DocumentDbCollectionDatasetTypeProperties = original.DocumentDbCollectionDatasetTypeProperties
type DocumentDbCollectionSink = original.DocumentDbCollectionSink
type DocumentDbCollectionSource = original.DocumentDbCollectionSource
type DynamicsEntityDataset = original.DynamicsEntityDataset
type DynamicsEntityDatasetTypeProperties = original.DynamicsEntityDatasetTypeProperties
type DynamicsLinkedService = original.DynamicsLinkedService
type DynamicsLinkedServiceTypeProperties = original.DynamicsLinkedServiceTypeProperties
type DynamicsSink = original.DynamicsSink
type DynamicsSource = original.DynamicsSource
type ErrorResponse = original.ErrorResponse
type ExecutePipelineActivity = original.ExecutePipelineActivity
type ExecutePipelineActivityTypeProperties = original.ExecutePipelineActivityTypeProperties
type ExecutionActivity = original.ExecutionActivity
type Expression = original.Expression
type Factory = original.Factory
type FactoryIdentity = original.FactoryIdentity
type FactoryListResponse = original.FactoryListResponse
type FactoryProperties = original.FactoryProperties
type FactoryUpdateParameters = original.FactoryUpdateParameters
type FileServerLinkedService = original.FileServerLinkedService
type FileServerLinkedServiceTypeProperties = original.FileServerLinkedServiceTypeProperties
type FileShareDataset = original.FileShareDataset
type FileShareDatasetTypeProperties = original.FileShareDatasetTypeProperties
type FileSystemSink = original.FileSystemSink
type FileSystemSource = original.FileSystemSource
type ForEachActivity = original.ForEachActivity
type ForEachActivityTypeProperties = original.ForEachActivityTypeProperties
type FtpServerLinkedService = original.FtpServerLinkedService
type FtpServerLinkedServiceTypeProperties = original.FtpServerLinkedServiceTypeProperties
type GetMetadataActivity = original.GetMetadataActivity
type GetMetadataActivityTypeProperties = original.GetMetadataActivityTypeProperties
type HdfsLinkedService = original.HdfsLinkedService
type HdfsLinkedServiceTypeProperties = original.HdfsLinkedServiceTypeProperties
type HdfsSource = original.HdfsSource
type HDInsightHiveActivity = original.HDInsightHiveActivity
type HDInsightHiveActivityTypeProperties = original.HDInsightHiveActivityTypeProperties
type HDInsightLinkedService = original.HDInsightLinkedService
type HDInsightLinkedServiceTypeProperties = original.HDInsightLinkedServiceTypeProperties
type HDInsightMapReduceActivity = original.HDInsightMapReduceActivity
type HDInsightMapReduceActivityTypeProperties = original.HDInsightMapReduceActivityTypeProperties
type HDInsightOnDemandLinkedService = original.HDInsightOnDemandLinkedService
type HDInsightOnDemandLinkedServiceTypeProperties = original.HDInsightOnDemandLinkedServiceTypeProperties
type HDInsightPigActivity = original.HDInsightPigActivity
type HDInsightPigActivityTypeProperties = original.HDInsightPigActivityTypeProperties
type HDInsightSparkActivity = original.HDInsightSparkActivity
type HDInsightSparkActivityTypeProperties = original.HDInsightSparkActivityTypeProperties
type HDInsightStreamingActivity = original.HDInsightStreamingActivity
type HDInsightStreamingActivityTypeProperties = original.HDInsightStreamingActivityTypeProperties
type HTTPDataset = original.HTTPDataset
type HTTPDatasetTypeProperties = original.HTTPDatasetTypeProperties
type HTTPLinkedService = original.HTTPLinkedService
type HTTPLinkedServiceTypeProperties = original.HTTPLinkedServiceTypeProperties
type HTTPSource = original.HTTPSource
type IfConditionActivity = original.IfConditionActivity
type IfConditionActivityTypeProperties = original.IfConditionActivityTypeProperties
type IntegrationRuntime = original.IntegrationRuntime
type IntegrationRuntimeAuthKeys = original.IntegrationRuntimeAuthKeys
type IntegrationRuntimeComputeProperties = original.IntegrationRuntimeComputeProperties
type IntegrationRuntimeConnectionInfo = original.IntegrationRuntimeConnectionInfo
type IntegrationRuntimeListResponse = original.IntegrationRuntimeListResponse
type IntegrationRuntimeMonitoringData = original.IntegrationRuntimeMonitoringData
type IntegrationRuntimeNodeMonitoringData = original.IntegrationRuntimeNodeMonitoringData
type IntegrationRuntimeReference = original.IntegrationRuntimeReference
type IntegrationRuntimeRegenerateKeyParameters = original.IntegrationRuntimeRegenerateKeyParameters
type IntegrationRuntimeRemoveNodeRequest = original.IntegrationRuntimeRemoveNodeRequest
type IntegrationRuntimeResource = original.IntegrationRuntimeResource
type IntegrationRuntimeSsisCatalogInfo = original.IntegrationRuntimeSsisCatalogInfo
type IntegrationRuntimeSsisProperties = original.IntegrationRuntimeSsisProperties
type IntegrationRuntimeStatus = original.IntegrationRuntimeStatus
type IntegrationRuntimeStatusListResponse = original.IntegrationRuntimeStatusListResponse
type IntegrationRuntimeStatusResponse = original.IntegrationRuntimeStatusResponse
type IntegrationRuntimeVNetProperties = original.IntegrationRuntimeVNetProperties
type JSONFormat = original.JSONFormat
type LinkedService = original.LinkedService
type LinkedServiceListResponse = original.LinkedServiceListResponse
type LinkedServiceReference = original.LinkedServiceReference
type LinkedServiceResource = original.LinkedServiceResource
type LookupActivity = original.LookupActivity
type LookupActivityTypeProperties = original.LookupActivityTypeProperties
type ManagedIntegrationRuntime = original.ManagedIntegrationRuntime
type ManagedIntegrationRuntimeError = original.ManagedIntegrationRuntimeError
type ManagedIntegrationRuntimeNode = original.ManagedIntegrationRuntimeNode
type ManagedIntegrationRuntimeOperationResult = original.ManagedIntegrationRuntimeOperationResult
type ManagedIntegrationRuntimeStatus = original.ManagedIntegrationRuntimeStatus
type ManagedIntegrationRuntimeStatusTypeProperties = original.ManagedIntegrationRuntimeStatusTypeProperties
type ManagedIntegrationRuntimeTypeProperties = original.ManagedIntegrationRuntimeTypeProperties
type MongoDbCollectionDataset = original.MongoDbCollectionDataset
type MongoDbCollectionDatasetTypeProperties = original.MongoDbCollectionDatasetTypeProperties
type MongoDbLinkedService = original.MongoDbLinkedService
type MongoDbLinkedServiceTypeProperties = original.MongoDbLinkedServiceTypeProperties
type MongoDbSource = original.MongoDbSource
type MySQLLinkedService = original.MySQLLinkedService
type MySQLLinkedServiceTypeProperties = original.MySQLLinkedServiceTypeProperties
type ODataLinkedService = original.ODataLinkedService
type ODataLinkedServiceTypeProperties = original.ODataLinkedServiceTypeProperties
type ODataResourceDataset = original.ODataResourceDataset
type ODataResourceDatasetTypeProperties = original.ODataResourceDatasetTypeProperties
type OdbcLinkedService = original.OdbcLinkedService
type OdbcLinkedServiceTypeProperties = original.OdbcLinkedServiceTypeProperties
type OdbcSink = original.OdbcSink
type Operation = original.Operation
type OperationDisplay = original.OperationDisplay
type OperationListResponse = original.OperationListResponse
type OperationLogSpecification = original.OperationLogSpecification
type OperationMetricAvailability = original.OperationMetricAvailability
type OperationMetricSpecification = original.OperationMetricSpecification
type OperationProperties = original.OperationProperties
type OperationServiceSpecification = original.OperationServiceSpecification
type OracleLinkedService = original.OracleLinkedService
type OracleLinkedServiceTypeProperties = original.OracleLinkedServiceTypeProperties
type OracleSink = original.OracleSink
type OracleSource = original.OracleSource
type OracleTableDataset = original.OracleTableDataset
type OracleTableDatasetTypeProperties = original.OracleTableDatasetTypeProperties
type OrcFormat = original.OrcFormat
type ParameterSpecification = original.ParameterSpecification
type ParquetFormat = original.ParquetFormat
type Pipeline = original.Pipeline
type PipelineListResponse = original.PipelineListResponse
type PipelineReference = original.PipelineReference
type PipelineResource = original.PipelineResource
type PipelineRun = original.PipelineRun
type PipelineRunFilterParameters = original.PipelineRunFilterParameters
type PipelineRunInvokedBy = original.PipelineRunInvokedBy
type PipelineRunQueryFilter = original.PipelineRunQueryFilter
type PipelineRunQueryOrderBy = original.PipelineRunQueryOrderBy
type PipelineRunQueryResponse = original.PipelineRunQueryResponse
type PolybaseSettings = original.PolybaseSettings
type PostgreSQLLinkedService = original.PostgreSQLLinkedService
type PostgreSQLLinkedServiceTypeProperties = original.PostgreSQLLinkedServiceTypeProperties
type RecurrenceSchedule = original.RecurrenceSchedule
type RecurrenceScheduleOccurrence = original.RecurrenceScheduleOccurrence
type RedirectIncompatibleRowSettings = original.RedirectIncompatibleRowSettings
type RedshiftUnloadSettings = original.RedshiftUnloadSettings
type RelationalSource = original.RelationalSource
type RelationalTableDataset = original.RelationalTableDataset
type RelationalTableDatasetTypeProperties = original.RelationalTableDatasetTypeProperties
type Resource = original.Resource
type SalesforceLinkedService = original.SalesforceLinkedService
type SalesforceLinkedServiceTypeProperties = original.SalesforceLinkedServiceTypeProperties
type SalesforceObjectDataset = original.SalesforceObjectDataset
type SalesforceObjectDatasetTypeProperties = original.SalesforceObjectDatasetTypeProperties
type SalesforceSink = original.SalesforceSink
type SalesforceSource = original.SalesforceSource
type SapBWLinkedService = original.SapBWLinkedService
type SapBWLinkedServiceTypeProperties = original.SapBWLinkedServiceTypeProperties
type SapCloudForCustomerLinkedService = original.SapCloudForCustomerLinkedService
type SapCloudForCustomerLinkedServiceTypeProperties = original.SapCloudForCustomerLinkedServiceTypeProperties
type SapCloudForCustomerResourceDataset = original.SapCloudForCustomerResourceDataset
type SapCloudForCustomerResourceDatasetTypeProperties = original.SapCloudForCustomerResourceDatasetTypeProperties
type SapCloudForCustomerSource = original.SapCloudForCustomerSource
type SapHanaLinkedService = original.SapHanaLinkedService
type SapHanaLinkedServiceProperties = original.SapHanaLinkedServiceProperties
type ScheduleTrigger = original.ScheduleTrigger
type ScheduleTriggerRecurrence = original.ScheduleTriggerRecurrence
type ScheduleTriggerTypeProperties = original.ScheduleTriggerTypeProperties
type SecretBase = original.SecretBase
type SecureString = original.SecureString
type SelfHostedIntegrationRuntime = original.SelfHostedIntegrationRuntime
type SelfHostedIntegrationRuntimeNode = original.SelfHostedIntegrationRuntimeNode
type SelfHostedIntegrationRuntimeStatus = original.SelfHostedIntegrationRuntimeStatus
type SelfHostedIntegrationRuntimeStatusTypeProperties = original.SelfHostedIntegrationRuntimeStatusTypeProperties
type SftpServerLinkedService = original.SftpServerLinkedService
type SftpServerLinkedServiceTypeProperties = original.SftpServerLinkedServiceTypeProperties
type SQLDWSink = original.SQLDWSink
type SQLDWSource = original.SQLDWSource
type SQLServerLinkedService = original.SQLServerLinkedService
type SQLServerLinkedServiceTypeProperties = original.SQLServerLinkedServiceTypeProperties
type SQLServerStoredProcedureActivity = original.SQLServerStoredProcedureActivity
type SQLServerStoredProcedureActivityTypeProperties = original.SQLServerStoredProcedureActivityTypeProperties
type SQLServerTableDataset = original.SQLServerTableDataset
type SQLServerTableDatasetTypeProperties = original.SQLServerTableDatasetTypeProperties
type SQLSink = original.SQLSink
type SQLSource = original.SQLSource
type StagingSettings = original.StagingSettings
type StoredProcedureParameter = original.StoredProcedureParameter
type SubResource = original.SubResource
type SybaseLinkedService = original.SybaseLinkedService
type SybaseLinkedServiceTypeProperties = original.SybaseLinkedServiceTypeProperties
type TabularTranslator = original.TabularTranslator
type TeradataLinkedService = original.TeradataLinkedService
type TeradataLinkedServiceTypeProperties = original.TeradataLinkedServiceTypeProperties
type TextFormat = original.TextFormat
type Trigger = original.Trigger
type TriggerListResponse = original.TriggerListResponse
type TriggerPipelineReference = original.TriggerPipelineReference
type TriggerResource = original.TriggerResource
type TriggerRun = original.TriggerRun
type TriggerRunListResponse = original.TriggerRunListResponse
type UntilActivity = original.UntilActivity
type UntilActivityTypeProperties = original.UntilActivityTypeProperties
type WaitActivity = original.WaitActivity
type WaitActivityTypeProperties = original.WaitActivityTypeProperties
type WebActivity = original.WebActivity
type WebActivityAuthentication = original.WebActivityAuthentication
type WebActivityTypeProperties = original.WebActivityTypeProperties
type WebAnonymousAuthentication = original.WebAnonymousAuthentication
type WebBasicAuthentication = original.WebBasicAuthentication
type WebClientCertificateAuthentication = original.WebClientCertificateAuthentication
type WebLinkedService = original.WebLinkedService
type WebLinkedServiceTypeProperties = original.WebLinkedServiceTypeProperties
type WebSource = original.WebSource
type WebTableDataset = original.WebTableDataset
type WebTableDatasetTypeProperties = original.WebTableDatasetTypeProperties
type OperationsClient = original.OperationsClient
type PipelinesClient = original.PipelinesClient
type ActivityRunsClient = original.ActivityRunsClient

const (
	DefaultBaseURI = original.DefaultBaseURI
)

type ManagementClient = original.ManagementClient
type FactoriesClient = original.FactoriesClient
type IntegrationRuntimesClient = original.IntegrationRuntimesClient
type TriggersClient = original.TriggersClient
type DatasetsClient = original.DatasetsClient
type PipelineRunsClient = original.PipelineRunsClient

func NewFactoriesClient(subscriptionID string) FactoriesClient {
	return original.NewFactoriesClient(subscriptionID)
}
func NewFactoriesClientWithBaseURI(baseURI string, subscriptionID string) FactoriesClient {
	return original.NewFactoriesClientWithBaseURI(baseURI, subscriptionID)
}
func NewIntegrationRuntimesClient(subscriptionID string) IntegrationRuntimesClient {
	return original.NewIntegrationRuntimesClient(subscriptionID)
}
func NewIntegrationRuntimesClientWithBaseURI(baseURI string, subscriptionID string) IntegrationRuntimesClient {
	return original.NewIntegrationRuntimesClientWithBaseURI(baseURI, subscriptionID)
}
func NewLinkedServicesClient(subscriptionID string) LinkedServicesClient {
	return original.NewLinkedServicesClient(subscriptionID)
}
func NewLinkedServicesClientWithBaseURI(baseURI string, subscriptionID string) LinkedServicesClient {
	return original.NewLinkedServicesClientWithBaseURI(baseURI, subscriptionID)
}
func NewOperationsClient(subscriptionID string) OperationsClient {
	return original.NewOperationsClient(subscriptionID)
}
func NewOperationsClientWithBaseURI(baseURI string, subscriptionID string) OperationsClient {
	return original.NewOperationsClientWithBaseURI(baseURI, subscriptionID)
}
func NewPipelinesClient(subscriptionID string) PipelinesClient {
	return original.NewPipelinesClient(subscriptionID)
}
func NewPipelinesClientWithBaseURI(baseURI string, subscriptionID string) PipelinesClient {
	return original.NewPipelinesClientWithBaseURI(baseURI, subscriptionID)
}
func NewActivityRunsClient(subscriptionID string) ActivityRunsClient {
	return original.NewActivityRunsClient(subscriptionID)
}
func NewActivityRunsClientWithBaseURI(baseURI string, subscriptionID string) ActivityRunsClient {
	return original.NewActivityRunsClientWithBaseURI(baseURI, subscriptionID)
}
func New(subscriptionID string) ManagementClient {
	return original.New(subscriptionID)
}
func NewWithBaseURI(baseURI string, subscriptionID string) ManagementClient {
	return original.NewWithBaseURI(baseURI, subscriptionID)
}
func NewTriggersClient(subscriptionID string) TriggersClient {
	return original.NewTriggersClient(subscriptionID)
}
func NewTriggersClientWithBaseURI(baseURI string, subscriptionID string) TriggersClient {
	return original.NewTriggersClientWithBaseURI(baseURI, subscriptionID)
}
func UserAgent() string {
	return original.UserAgent() + " profiles/preview"
}
func Version() string {
	return original.Version()
}
func NewDatasetsClient(subscriptionID string) DatasetsClient {
	return original.NewDatasetsClient(subscriptionID)
}
func NewDatasetsClientWithBaseURI(baseURI string, subscriptionID string) DatasetsClient {
	return original.NewDatasetsClientWithBaseURI(baseURI, subscriptionID)
}
func NewPipelineRunsClient(subscriptionID string) PipelineRunsClient {
	return original.NewPipelineRunsClient(subscriptionID)
}
func NewPipelineRunsClientWithBaseURI(baseURI string, subscriptionID string) PipelineRunsClient {
	return original.NewPipelineRunsClientWithBaseURI(baseURI, subscriptionID)
}
