// Package management implements the Azure ARM Management service API version 2017-08-31-preview.
//
// The Azure Management Groups API enables consolidation of multiple
// subscriptions/resources into an organizational hierarchy and centrally
// manage access control, policies, alerting and reporting for those resources.
//
package management

// Copyright (c) Microsoft and contributors.  All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/Azure/go-autorest/autorest"
	"github.com/satori/go.uuid"
)

const (
	// DefaultBaseURI is the default URI used for the service Management
	DefaultBaseURI = "https://management.azure.com"
)

// ManagementClient is the base client for Management.
type ManagementClient struct {
	autorest.Client
	BaseURI string
	GroupID uuid.UUID
}

// New creates an instance of the ManagementClient client.
func New(groupID uuid.UUID) ManagementClient {
	return NewWithBaseURI(DefaultBaseURI, groupID)
}

// NewWithBaseURI creates an instance of the ManagementClient client.
func NewWithBaseURI(baseURI string, groupID uuid.UUID) ManagementClient {
	return ManagementClient{
		Client:  autorest.NewClientWithUserAgent(UserAgent()),
		BaseURI: baseURI,
		GroupID: groupID,
	}
}
